// Generated by the WebObjects Wizard

import com.apple.yellow.foundation.*;
import com.apple.yellow.webobjects.*;
import com.apple.yellow.eocontrol.*;
import sun.security.x509.*;
import java.security.*;
import java.io.*;
import com.dln.*;

public class Application extends APApplication {

    protected VACertCheck vc;
    protected String caCertString;
    protected X509Cert caCert;
    
    public Application() {
        super();
        System.out.println("Welcome to " + this.name() + " !");
        /* ** put your initialization code in here ** */
        //setLogRequest(true);
        //setLogResponse(true);
        setLogRequestFormValues(true);
        setLogRequestProperties(false);
        setLogResponseProperties(false);
        setLogRequestContent(false);
        setLogResponseContent(false);
        setLogRequestCookies(true);
        setLogResponseCookies(true);
        setLogRequestHeaders(true);
        
        NSMutableArray pgs = new NSMutableArray();
        pgs.addObject("Page1");
        pgs.addObject("Page2");
        pgs.addObject("PolicyEditorPage");
        pgs.addObject("Main"); // require only Page2 to demand a login
        
        NSMutableArray spgs = new NSMutableArray();
        spgs.addObject("Page2");
        spgs.addObject("CNFConfessionEntry");
        spgs.addObject("CNFConfessionSignature");
        //spgs.addObject("CNFConfessionConfirmation");
       
        //spgs.addObject("Main"); // show only Page1 and Main pages in insecure mode

        NSMutableArray actions = new NSMutableArray();
        actions.addObject("DirectAction/default"); // allow only THIS DirectAction unlogged in

        APAuthPolicy ap = APAuthPolicy.authPolicy();        
        ap.setShouldDenyAllPages(true);
        ap.setPagesToAllow(pgs);
        ap.setShouldDenyAllActions(true);
        ap.setActionsToAllow(actions);
        ap.setShouldDenyAllPagesNotInSecureMode(false);
        ap.setPagesToDenyNotInSecureMode(spgs);

        //ap.setLoginMethod(APAuthPolicyAbstract.CERTIFICATE);
        //ap.setLoginMethod(APAuthPolicyAbstract.HTTP_PANEL);
        ap.setShouldDisplayLoginOnTimeout(true);
        ap.setDelegate(this);
        ap.setDefaultDestinationPageName("Main");
        ap.setShouldAlwaysUseDefaultDestination(false);

        ap.setShouldAllowFallbackLoginOnMissingCert (false);
        ap.setFallbackLoginMethod(APAuthPolicyAbstract.HTTP_PANEL);
        ap.setShouldAllowSessionWithoutLogin(true);
        vc = new VACertCheck();
        gatherTrustedCACertFromFile();
    }

    public boolean allowsConcurrentRequestHandling(){
        return true;
    }

    public NSObject authorizeUsernamePassword(String user, String pass){
        System.out.println("Application: authorizeUsernamePassword: user: =" + user + "=");
        System.out.println("Application: authorizeUsernamePassword: pass: =" + pass + "=");
        if(user != null)
            if(user.equals(pass) && !user.equals("")){
                return new NSDictionary();
            }
        return null;
    }
    public NSObject authorizeUserCertificate(sun.security.x509.X509Cert cert, String base64String, NSMutableDictionary userInfo){
        System.out.println("Application: authorizeUserCertificate:");
        if(cert != null){
            X500Name subjectName = cert.getSubjectName();
            String nm = subjectName.getName();
            String cn = null;
            NSDictionary res = vc.validateWithStrings("OCSP", base64String, caCertString);
            String status = (String)res.objectForKey("CERT_STATUS");
            userInfo.setObjectForKey(res, "VALIDATION_RESULTS");
            if(status != null){
                if(status.equals("OK")){
                    System.out.println("Application: authorizeUserCertificate: status OK");
                }else if(status.equals("REVOKED")){
                    userInfo.setObjectForKey("CERT STATUS REVOKED", "REASON");
                    System.out.println("Application: authorizeUserCertificate: status REVOKED");
                    return null;
                }else{
                    userInfo.setObjectForKey("CERT STATUS UNKNOWN", "REASON");
                    System.out.println("Application: authorizeUserCertificate: status UNKNOWN");
                    return null;
                }
            }else{
                userInfo.setObjectForKey("COULD NOT GET STATUS RESPONSE", "REASON");
                System.out.println("Application: authorizeUserCertificate: validation failed");
                return null;
            }
            
            try{
                cn = subjectName. getCommonName ();
                if(cn != null)
                    if(cn.equals("David Neumann")) return new NSDictionary();
                userInfo.setObjectForKey("USER NOT GRANTED ACCESS", "REASON");
            }catch(java.io.IOException ex){
                System.out.println("Application: authorizeUserCertificate: prob getting common name");
            }
        }
        return null;
    }

    public void gatherTrustedCACertFromFile(){
        String path = "th-root.cer";
        try{
            InputStream in = new FileInputStream(path);
            File file = new File(path);
            caCertString = stringFromFile(file);
            in.close();
            //sun.misc.BASE64Decoder decoder=new sun.misc.BASE64Decoder();
            //caCert = new sun.security.x509.X509Cert (decoder.decodeBuffer(new ByteArrayInputStream(caCertString.getBytes()) ));
        }catch(IOException ex){
            System.out.println("APAuthPolicy:: IOException creating FileInputStream or cert");
        }
    }
    
    static public String stringFromFile(File f) throws IOException {
        if (f==null)
            throw new IOException("null file");
        int size=(int) f.length();
        FileInputStream fis=new FileInputStream(f);
        byte [] data = new byte[size];
        int bytesRead=0;
        while (bytesRead<size)
            bytesRead+=fis.read(data,bytesRead,size-bytesRead);
        fis.close();
        return new String(data);
    }

}
