/* VACertCheck.h created by Administrator on Thu 11-May-2000 */

#import <WebObjects/WebObjects.h>
#import <Foundation/Foundation.h>

@interface VACertCheck : NSObject
{
    NSString *vaURL;
}

- init;

// URL like "http://host:80" for the
// Validation Authority (VA) you wish to use
// defaults to the URL for the ValiCert
// Global Validation Service (GVAS).
- (NSString *)vaURL;
- (void)setVaURL:(NSString *)newVaURL;

// The method can be either "OCSP" or "CRT"
// The cert arg is the cert being validated
// The ca arg is the cert for the CA that issued the cert being validated
// The files and strings passed must be in Base64 (or PEM) format
// The returned dict has these keys:
//    RESPONSE_STATUS = either YES|NO;
//	If RESPONSE_STATUS is NO, then none of the other statuses will appear
//	This status is the only key always present
//    CERT_STATUS = either: 
//	OK
//	REVOKED
//	UNKNOWN
//	CRL_EXPIRED
//	CRL_NOT_YET_VALID
//	STATUS_RESP_EXPIRED
//	RESP_NOT_YET_VALID
//	UNKNOWN_STATUS
//    ISSUER = for ex: "/L=ValiCert Validation Network/O=ValiCert, Inc./OU=Class 1 Validation Authority - OCSP/CN=http://www.valicert.net//Email=info@valicert.com"; 
//    ISSUE_TIME = for ex: "Sat May 13 14:43:06 2000\n"; 
//    PROTOCOL = either OCSP|CRT; 
//    VERSION = for ex: 0; 
//    REVOCATION_REASON = a code number 
//	(optional and only present if revoked)
//    REVOCATION_TIME = for ex: "Sat May 13 14:43:06 2000\n"; 
//	(optional and only present if revoked)

- (NSDictionary *)validateWithFiles:(NSString *)method cert:(NSString *)certFile ca:(NSString *)caCertFile;
- (NSDictionary *)validateWithStrings:(NSString *)method cert:(NSString *)cert ca:(NSString *)caCert;

@end
