/* VACertCheck.m created by Administrator on Thu 11-May-2000 */
#import "VACertCheck.h"
#include <vtk_defs.h>
#import "VASupport.h"

@implementation VACertCheck

+ (NSString *)beginCertHeader{
    return @"-----BEGIN CERTIFICATE-----\n";
}
+ (NSString *)endCertHeader{
    return @"\n-----END CERTIFICATE-----";
}

- init{
    Vtk_uint32 retCode;
    self = [super init];
    /*
     * Initialize the toolkit library.
     */
    retCode = Vtk_Init();
    if (retCode != VTK_OK){
        NSLog(@"Vtk_Init error");
            showError("Vtk_Init", retCode);
    }
    NSLog(@"VTK_GVAS_URL:%s", VTK_GVAS_URL);
    [self setVaURL:[NSString stringWithCString: VTK_GVAS_URL]];
    return self;
}
- (void)dealloc{
   /*
    * Release toolkit resources.
    */
    Vtk_Finish();
    [vaURL release];
    [super dealloc];
}


- (NSString *)vaURL {
    return vaURL;
}
- (void)setVaURL:(NSString *)newVaURL { 
    [newVaURL retain];
    [vaURL release];
    vaURL = newVaURL;
}

+ (int)methodFromString:(NSString *)s{
    if([s isEqualToString:@"OCSP"]) return VTK_VM_OCSP;
    return VTK_VM_CRT;
}

+ (NSString *)formattedString:(NSString *)s{
    NSString *a = [[self class] beginCertHeader];
    NSArray *cps = [s componentsSeparatedByString:[[self class] beginCertHeader]];
    if([cps count] > 1){
        return s;
    }
    a = [a stringByAppendingString:s];
    a = [a stringByAppendingString:[[self class] endCertHeader]];
    return a;
}
- (NSDictionary *)validateWithFiles:(NSString *)method cert:(NSString *)certFile ca:(NSString *)caCertFile{
    NSDictionary *result = SimpleValidation([VACertCheck methodFromString:method], [certFile cString], [caCertFile cString], [[self vaURL] cString], VA_FILE);
    NSLog(@"validateWithFiles: result:%@", result);
    return result;
}
- (NSDictionary *)validateWithStrings:(NSString *)method cert:(NSString *)cert ca:(NSString *)caCert {
    NSDictionary *result = SimpleValidation([VACertCheck methodFromString:method], [[VACertCheck formattedString:cert] cString], [[VACertCheck formattedString:caCert] cString], [[self vaURL] cString], VA_STRING);
    NSLog(@"validateWithStrings: result:%@", result);
    return result;
}

@end
