/* VASupport.h created by Administrator on Fri 12-May-2000 */
#import <Foundation/Foundation.h>

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <assert.h>
#include <string.h>
#include <memory.h>

/*
 * Toolkit includes.
 */
#include <vtk_defs.h>
#include <vtk_cert.h>
#include <vtk_error.h>
#include <vtk_ctxt.h>
#include <vtk_valid.h>

/*
 * Copyright 1999 ValiCert Inc. All Rights Reserved.
 *
 * $Id: vtksample.c,v 1.6 2000/03/02 03:56:43 stefank Exp $
 *
 *
 * ValiCert Validator Toolkit Sample Program.
 *
 * This file demonstrates performing common operations with the
 * ValidCert Validator Toolkit.
 */

enum Vtk_InputContainer {
	VA_FILE = 1,
	VA_DATA,
	VA_STRING
};


/*
 * SimpleValdiation
 *
 * Performs a simple OCSP or CRT validate for the passed in certificate
 * against the Global Validation Authority Service (GVAS).
 */
NSDictionary *SimpleValidation (enum Vtk_ValidationMech mech, const char *userCertFile, const char *caCertFile, const char *vaURL, enum Vtk_InputContainer inputType);

/*
 * showError
 *
 * Displays a textual representation of the Validator Toolkit error
 */
void showError(const char *funcName, Vtk_uint32 code);

/*
 * displayValidationDetails
 * Prints certificate validation details.
 */
void displayValidationDetails(const Vtk_Ctxt *ctxt, const Vtk_ValHdl *hdl);

/*
 * DisplayCert
 * Prints detailed information for the suppied certificate.
 */
void DisplayCert(const Vtk_Ctxt *ctxt, const Vtk_Cert *cert, const char *label);


