/* APApplication.java created by Administrator on Fri 28-Apr-2000 
   based on LoggingApplication.java created by Kelly Kazem on Mon 07-Feb-2000
*/

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;
import sun.security.*;
import java.security.*;

public class APApplication extends WOApplication implements APAuthenticationDelegate, APResponseGenerator {

    boolean _logRequest;
    boolean _logRequestHeaders;
    boolean _logRequestCookies;
    boolean _logRequestContent;
    boolean _logRequestFormValues;
    boolean _logRequestProperties;

    boolean _logResponse;
    boolean _logResponseHeaders;
    boolean _logResponseCookies;
    boolean _logResponseContent;
    boolean _logResponseProperties;


    public  boolean logRequest(){return _logRequest;}
    public  void setLogRequest(boolean flg){_logRequest=flg;}
    public  void setLogResponse(boolean flg){_logResponse=flg;}
    public  boolean logResponse(){return _logResponse;}

    public  boolean logRequestFormValues(){return _logRequestFormValues;}
    public  void setLogRequestFormValues(boolean flg){_logRequestFormValues=flg;}

    public  boolean logRequestProperties(){return _logRequestProperties;}
    public  void setLogRequestProperties(boolean flg){_logRequestProperties=flg;}
    public  void setLogResponseProperties(boolean flg){_logResponseProperties=flg;}
    public  boolean logResponseProperties(){return _logResponseProperties;}

    public  boolean logRequestContent(){return _logRequestContent;}
    public  void setLogRequestContent(boolean flg){_logRequestContent=flg;}
    public  void setLogResponseContent(boolean flg){_logResponseContent=flg;}
    public  boolean logResponseContent(){return _logResponseContent;}

    public  boolean logRequestCookies(){return _logRequestCookies;}
    public  void setLogRequestCookies(boolean flg){_logRequestCookies=flg;}
    public  void setLogResponseCookies(boolean flg){_logResponseCookies=flg;}
    public  boolean logResponseCookies(){return _logResponseCookies;}

    public  boolean logRequestHeaders(){return _logRequestHeaders;}
    public  void setLogRequestHeaders(boolean flg){_logRequestHeaders=flg;}
    public  void setLogResponseHeaders(boolean flg){_logResponseHeaders=flg;}
    public  boolean logResponseHeaders(){return _logResponseHeaders;}


    public WOResponse dispatchRequest(WORequest aRequest){
        WOResponse aResponse;

        if(_logRequest)
            RequestLogger.logRequest(aRequest);
        else{
            if(_logRequestHeaders)
                RequestLogger.logRequestHeaders(aRequest);
            if(_logRequestFormValues)
                RequestLogger.logRequestFormValues(aRequest);
            if(_logRequestCookies)
                RequestLogger.logRequestCookies(aRequest);
            if(_logRequestContent)
                RequestLogger.logRequestContent(aRequest);
            if(_logRequestProperties)
                RequestLogger.logRequestProperties(aRequest);
        }

        aResponse=super.dispatchRequest(aRequest);//the request-response loop
            if(_logResponse)
                ResponseLogger.logResponse(aResponse);
        else{
            if(_logResponseHeaders)
                ResponseLogger.logResponseHeaders(aResponse);
            if(_logResponseCookies)
                ResponseLogger.logResponseCookies(aResponse);
            if(_logResponseContent)
                ResponseLogger.logResponseContent(aResponse);
            if(_logResponseProperties)
                ResponseLogger.logResponseProperties(aResponse);
        }

        return aResponse;
    }

    public APApplication () {
        super();
        System.out.println("Welcome to APApplication");
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        setDefaultRequestHandler(requestHandlerForKey(WOApplication.directActionRequestHandlerKey()));
    }

    public void awake(){
        super.awake();
    }

    public WOSession createSessionForRequest(WORequest aRequest){
        return super.createSessionForRequest(aRequest);
    }

    public WOElement invokeAction(WORequest aRequest, WOContext aContext){
        return super.invokeAction(aRequest, aContext);
    }


    private String httpRedirectURL(WOContext aContext, boolean isSecure){
        WORequest req = aContext.request();
        String host = req.headerForKey("SERVER_NAME");
        if(host == null) host = req.headerForKey("HTTP_HOST");
        String protocol = "http://";
        if(isSecure) protocol = "https://";
        String url = protocol + host + req.adaptorPrefix() + "/" + req.applicationName();
        System.out.println("APApplication: httpRedirectURL: url:"+url);
        System.out.println("APApplication: httpRedirectURL: reqKey:"+ req.requestHandlerKey());
        System.out.println("APApplication: httpRedirectURL: reqPath:"+ req.requestHandlerPath());
        System.out.println("APApplication: httpRedirectURL: uri:"+ req.uri());
        return url;
    }
    private WOResponse redirectForLogin(WOContext aContext, boolean isSecure){
        WORedirect nextPage = (WORedirect)pageWithName("WORedirect", aContext);
        nextPage.setURL(httpRedirectURL(aContext, isSecure));
        return nextPage.generateResponse();
    }
    public WOResponse handleSessionRestorationErrorInContext(WOContext aContext) {
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        if(ap.shouldDisplayLoginOnTimeout()){
            WOResponse loginResp = null;
            String pgName = ap.defaultDestinationPageName();
            WOComponent pg = aContext.page();
            if(pg != null){
                System.out.println("APApplication: handleSessionRestorationErrorInContext: pg not null");
                pgName = pg.name();
            }
            System.out.println("APApplication: handleSessionRestorationErrorInContext: pgName:"+ pgName);
            if(ap.loginMethod() == APAuthPolicyAbstract.HTTP_PANEL){
                return redirectForLogin(aContext, false);
            }else if(ap.loginMethod() == APAuthPolicyAbstract.CERTIFICATE){
                //if(!ap.requestIsSecurePrimitive(aContext.request())){
                //    return redirectForLogin(aContext, true);
                //}
                if(!ap.requestIsSecure(aContext.request()) && ap.shouldAllowFallbackLoginOnMissingCert()){
                    if(ap.fallbackLoginMethod () == APAuthPolicyAbstract.HTTP_PANEL){
                        return redirectForLogin(aContext, false);
                    }else{
                        APLoginPage nextPage = ap.loginPage(aContext);
                        nextPage.setIsSessionRestorationError(true);
                        loginResp = nextPage.generateResponse();
                    }
                }else{
                    if(ap.requestIsSecure(aContext.request())){
                        WOComponent nextPage = pageWithName(pgName, aContext);
                        loginResp = nextPage.generateResponse();
                    }else{
                        APAccessDeniedPage lp = ap.accessDeniedPage(aContext);
                        lp.setMessage("Your session timed-out. And you need to connect with a digital certificate to login");
                        lp.setType("SESSION_TIMEOUT");
                        return lp.generateResponse();
                    }
                }
            }else{
                APLoginPage nextPage = ap.loginPage(aContext);
                nextPage.setIsSessionRestorationError(true);
                loginResp = nextPage.generateResponse();
            }
            return ap.loginResponse(loginResp, aContext, pgName, true);
        }
        return super.handleSessionRestorationErrorInContext(aContext);
    }

    public NSObject authorizeUserCertificate(sun.security.x509.X509Cert cert, String base64String, NSMutableDictionary userInfo){
        return null;
    }
    public NSObject authorizeUsernamePassword(String user, String pass){
        return null;
    }
    public WOComponent pageRedirectAfterAuthorization(NSObject authResult, WOContext context, String destPageName){
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        WOComponent pg = pageWithName(ap.defaultDestinationPageName(), context);
        if(destPageName != null && !ap.shouldAlwaysUseDefaultDestination() && destPageName.length() > 0){
            pg = pageWithName(destPageName, context);
        }
        return pg;
    }
    public boolean requestIsSecure(WORequest r){
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        return ap.requestIsSecurePrimitive(r);
    }


    public void finishResponseProcessing(WOResponse aResponse, WOContext aContext){
        System.out.println("APApplication: finishResponseProcessing:");
        super.appendToResponse (aResponse, aContext);
    }

    //public void appendToResponse(WOResponse aResponse, WOContext aContext){
    //    APAuthPolicy ap = APAuthPolicy.authPolicy();
    //    ap.processResponseForAccess(aResponse, aContext, this);
    //}

}

