/* APDirectAction.java created by Administrator on Fri 28-Apr-2000 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;

public class APDirectAction extends WODirectAction {

    public APDirectAction(WORequest aRequest) {
        super(aRequest);
    }

    public WOComponent testAction(){
        return pageWithName("Page1");
    }
    public WOComponent test2Action(){
        return pageWithName("Page2");
    }

    private String directActionClassFromPath(String path){
        if(path != null){
            NSArray arr = NSArray.componentsSeparatedByString(path, "/");
            if(arr.count() > 1){
                String cl = (String)arr.objectAtIndex(0);
                return cl;
            }
        }
        return "DirectAction";
    }


    public WOActionResults performActionNamed(String anActionName){
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        APLoginPage p = (APLoginPage)pageWithName(ap.loginPageName());
        String className = getClass().getName();
        WOContext aContext = p.context();
        System.out.println("APDirectAction: performActionNamed: anActionName:"+ anActionName);
        WOResponse aResponse = p.generateResponse();

        if(ap.loginMethod() == APAuthPolicyAbstract.HTTP_PANEL){
            System.out.println("APDirectAction: performActionNamed: HTTP_PANEL special processing");        
            // this will look for authorization header and log you
            // in if it finds it OK. The response is modified to take
            // you to the login page destination desired
            WORequest aRequest = aContext.request();
            if(ap.shouldHandleSessionlessAuthorizationRequest(aContext, this)){
                System.out.println("APDirectAction: performActionNamed: auth header there and NOT logged in");        
                // We only handle an authorization request IF it has the
                // "authorization" header in it AND we are not currently logged in
                // If we see the header then we know a HTTP login was attempted
                // and if we're not logged in, we know it wasn't successfully
                // concluded... although it might be after we handle it here
                WOResponse r = ap.handleAuthorizationRequestForContext(aContext);
                System.out.println("APDirectAction: performActionNamed: about to skip rest of method");
                if(ap.isLoggedIn(aContext)){
                    System.out.println("APDirectAction: performActionNamed: handle succeeded, performing super");
                    return super.performActionNamed(anActionName);
                }
                System.out.println("APDirectAction: performActionNamed: handle failed returning override response");
                return r;
            }
        }

        if(ap.shouldDenyDirectAction(className + "/" + anActionName, aContext, (APGuardianSession)existingSession())){
            System.out.println("APDirectAction: performActionNamed: shouldDenyDirectAction");        
            WORequest r = aContext.request();
            NSDictionary d = customFormValues(r.formValues());
            String clssName = directActionClassFromPath(r.requestHandlerPath());
            if(ap.loginMethod() == APAuthPolicyAbstract.HTTP_PANEL){
                System.out.println("APDirectAction: performActionNamed: setting login page state for HTTP_PANEL");        
                System.out.println("APDirectAction: performActionNamed: about to call loginResponse");        
                ap.loginResponse(aResponse, aContext, ap.defaultDestinationPageName());
                // Set Cookies for on-demand login feature if no session
                // If there is a session, store this in session() objectForKey state
                //p.setFormValuesDict(d);
                //p.setDirectActionClass(clssName);
                //p.setDirectActionName(anActionName);
                //p.setIsComponentAction(false);
                return aResponse;
            }else if(ap.loginMethod() == APAuthPolicyAbstract.HTML_PAGE){
                System.out.println("APDirectAction: performActionNamed: setting login page state for HTML_PAGE");        
                p.setFormValuesDict(d); 
                p.setDirectActionClass(clssName);
                p.setDirectActionName(anActionName);
                p.setIsComponentAction(false);
                return p;
            }else if(ap.loginMethod() == APAuthPolicyAbstract.CERTIFICATE){
                System.out.println("APDirectAction: performActionNamed: setting login page state for CERTIFICATE");        
                ap.loginResponse(aResponse, aContext, ap.defaultDestinationPageName());
                if(!ap.isLoggedInForDirectAction(this)) return aResponse;
            }
        }
        System.out.println("APDirectAction: performActionNamed: done");        
        return super.performActionNamed(anActionName);
    }


    private boolean reservedKey(String akey){
        if(akey.equals("username") || akey.equals("password") || akey.equals("destinationPageName")) return true;
        return false;
    }
    private NSDictionary customFormValues(NSDictionary dict){
        NSMutableDictionary newDict = new NSMutableDictionary();
        if(dict != null){
            NSArray keys = dict.allKeys();
            int cnt = keys.count();
            int i;
            for(i=0; i<cnt; i++){
                String key = (String)keys.objectAtIndex(i);
                if(!reservedKey(key)){
                    NSArray val = (NSArray)dict.objectForKey(key);
                    String valString = (String)val.objectAtIndex(0);
                    newDict.setObjectForKey(valString, key);
                }
            }
        }
        return newDict;
    }

    private boolean isComponentAction(String v){
        if(v == null)return true;
        if(v.equals("NO"))return false;
        return true;
    }

    public WOComponent loginPanelAction(){
        APLoginPage pg = (APLoginPage)pageWithName("APHTTPPanelLogin");
        return pg;
    }
    
    public WOComponent loginAction(){
        WOComponent successPage;
        WORequest req = request();
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        if(ap.isLoggedInForDirectAction(this)){
            APLoginPage pg = (APLoginPage)pageWithName(ap.loginPageName());
            pg.setAlreadyLoggedIn(true);
            return pg;
        }else{
            String uname = (String)req.formValueForKey("username");
            String pword = (String)req.formValueForKey("password");
            String dest = (String)req.formValueForKey("dpgn");
            String daName = (String)req.formValueForKey("dan");
            String daClass = (String)req.formValueForKey("dac");
            String isCompAction = (String)req.formValueForKey("icas");
            boolean isComponentAction = isComponentAction(isCompAction);
            NSDictionary d = customFormValues(req.formValues());
            if(dest == null || dest.equals("")) dest = ap.defaultDestinationPageName();
            //System.out.println("APDirectAction: loginAction: uname: =" + uname + "=");
            //System.out.println("APDirectAction: loginAction: pword: =" + pword + "=");
            //System.out.println("APDirectAction: loginAction: dest: =" + dest + "=");
            //System.out.println("APDirectAction: loginAction: d: =" + d + "=");
            //System.out.println("APDirectAction: loginAction: daName: =" + daName + "=");
            //System.out.println("APDirectAction: loginAction: daClass: =" + daClass + "=");
            //System.out.println("APDirectAction: loginAction: isCompAction: =" + isCompAction + "=");
            NSObject result = ap.authorizeUsernamePassword(uname, pword);
            APLoginPage pg = (APLoginPage)pageWithName(ap.loginPageName());
            WOContext context = pg.context();
            if(result == null){
                System.out.println("APDirectAction: loginAction: auth failed");
                pg.setUsername(uname);
                pg.setPassword(pword);
                pg.setLoginFailed(true);
                pg.setIsComponentAction(isComponentAction);
                pg.setAuthorizationResult(result);
                pg.setDestinationPageName(dest);
                pg.setDirectActionName(daName);
                pg.setDirectActionClass(daClass);
                pg.setFormValuesDict(d);
                return pg;
            }
            APGuardianSession s = (APGuardianSession)session();
            s.setIsLoggedIn(true);
            s.setAuthorizationResult(result);
            System.out.println("APDirectAction: loginAction: dest:"+ dest);
            if(ap.shouldDenyPageGenerationNotInSecureMode(context, dest)){
                successPage = ap.accessDeniedPage(context);
                successPage.takeValueForKey("This page must be accessed over a SSL connection","message");
                successPage.takeValueForKey("SSL_ACCESS", "type");
            }else{
                if(!isComponentAction){
                // in future attempt to invoke a DirectAction
                //Class cls = Class.forName(daClass);
                    successPage = ap.pageRedirectAfterAuthorization(result, context, dest);
                }else{
                    successPage = ap.pageRedirectAfterAuthorization(result, context, dest);
                }
            }
            WOResponse aResp = successPage.generateResponse();
            System.out.println("APDirectAction: loginAction: about to remove Cookie");
            aResp.setHeader("authCookie=0; expires=Sunday, 21-Feb-1966 10:00:00 GMT; path=/;","set-cookie");
        }
        return successPage;
    }

    
}
