/* APSSLSession.java created by Administrator on Sat 29-Apr-2000 
   based on SecureSession.java created by Kelly Kazem on Wed 12-Jan-2000 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;
import java.util.*;

public class APSSLSession extends WOSession {

    int _contextId;//to adjust for backtracking. The contextId when the secure mode was switched.
    boolean _isSecure;//are we currently secure
    boolean _fChangeSecureMode;//request secure mode change, so redirect only happens once.
    boolean _fSecureRequest;//request for secure or unsecure mode
    String _host;//host to redirect to

    public void setSecureWithHost(boolean makeSecure, String h){
        _contextId=contextIdFromRequest(context().request());
        if(_fChangeSecureMode==true)//if true, its from redirect, so reset
            _fChangeSecureMode = false;
        else{
            _fSecureRequest= makeSecure;
            _fChangeSecureMode = true;
        }
        _host=h;

        if(_host==null)//try to get host name from headers if not supplied
            _host=context().request().headerForKey("SERVER_NAME");
        if(_host==null)
            _host=context().request().headerForKey("HTTP_HOST");
    }
    
    public boolean isSecure(){return _isSecure;}

    public boolean isRequestSecure(){
        APAuthPolicy ap = APAuthPolicy.authPolicy();
        return ap.requestIsSecure(context().request());
    }

    public void appendToResponse(WOResponse aResponse, WOContext aContext){

        //track the state of the _secure flag based on the contextId
        if(_isSecure  && (_contextId>=contextIdFromRequest(context().request())) && _contextId< currentContextId()-2){
            //allowing for the redirect here
            _isSecure=false;
            _contextId=contextIdFromRequest(context().request());
        }
        else //the user might have backtracked to a secure page from a non-secure page.
        if(!_isSecure  && (_contextId>=contextIdFromRequest(context().request())) && _contextId< currentContextId()-2){
            //allowing for the redirect here
            _isSecure=true;
            _contextId=contextIdFromRequest(context().request());
        }
        super.appendToResponse(aResponse, aContext);
        if(_fChangeSecureMode && _fSecureRequest  ){
            aResponse.setStatus(302);
            aResponse.setHeader("https://"+_host+ aContext.request().uri(),"location");
            _isSecure=true;
        }else if(_fChangeSecureMode &&  !_fSecureRequest  ){
            aResponse.setStatus(302);
            aResponse.setHeader("http://"+_host+ aContext.request().uri(),"location");
            _isSecure=false;
        }
    }//end method

    int currentContextId(){
        return Integer.parseInt(context().contextID());
    }
    int contextIdFromRequest(WORequest aRequest){
        if(aRequest.requestHandlerPath()==null)
            return 0;// contextId is 0
        StringTokenizer st=new StringTokenizer(aRequest.requestHandlerPath(),"/.",false);
        if(st.countTokens()<2)//oops,looking for [sessionid]/[contextid].[elementid].<moreelementids>
            throw new RuntimeException("APSSLSession: unable to parse contextId from request.");
        st.nextToken();//skip over sessionId, next should be contextId
        return Integer.parseInt(st.nextToken());
    }

}
