/* RequestLogger.java created by Kelly Kazem on Wed 12-Jan-2000 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.webobjects.*;
import java.util.*;


public class RequestLogger  {

	public static void logRequest(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logRequest for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			RequestLogger.logRequest(aContext.request());
			System.out.println("**** Finished logRequest for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logRequestHeaders(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logRequestHeaders for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			RequestLogger.logRequestHeaders(aContext.request());
			System.out.println("**** Finished logRequestHeaders for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logRequestContent(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logRequestContent for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			RequestLogger.logRequestContent(aContext.request());
			System.out.println("**** Finished logRequestContent for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method


	public static void logRequestProperties(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logRequestProperties for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			RequestLogger.logRequestProperties(aContext.request());
			System.out.println("**** Finished logRequestProperties for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logRequestFormValues(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logRequestFormValues for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			RequestLogger.logRequestFormValues(aContext.request());
			System.out.println("**** Finished logRequestFormValues for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logRequestCookies(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logRequestCookies for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			RequestLogger.logRequestCookies(aContext.request());
			System.out.println("**** Finished logRequestCookies for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logRequest(WORequest aRequest){
        if(aRequest!=null){
			System.out.println("******** Begin logRequest ********");
			RequestLogger.logRequestProperties(aRequest);
			RequestLogger.logRequestHeaders(aRequest);
			RequestLogger.logRequestFormValues(aRequest);
			RequestLogger.logRequestCookies(aRequest);
			RequestLogger.logRequestContent(aRequest);
			System.out.println("******** End logRequest ********");
        }
    }//end method

	public static void logRequestCookies(WORequest aRequest){
       if(aRequest!=null){
			System.out.println("------------ Begin Request Cookies ------------");
			Enumeration en=aRequest.cookieValues().keyEnumerator();
        	while(en.hasMoreElements()){
				String ck=(String)en.nextElement();
				Enumeration en1=((NSArray)aRequest.cookieValues().objectForKey(ck)).objectEnumerator();
                while(en1.hasMoreElements()){
					System.out.println(ck+"="+en1.nextElement());
                }   
        	}
			System.out.println("------------ End Request Cookies ------------");
        }
    }//end method


	public static void logRequestFormValues(WORequest aRequest){
		if(aRequest!=null){
			System.out.println("------------ Begin Request Form Values ------------");
			Enumeration en=aRequest.formValueKeys().objectEnumerator();
        	while(en.hasMoreElements()){
				String fv=(String)en.nextElement();
				Enumeration en1=aRequest.formValuesForKey(fv).objectEnumerator();
                while(en1.hasMoreElements()){
					System.out.println(fv+"="+en1.nextElement());
                }
        	}
			System.out.println("formValueEncoding="+aRequest.formValueEncoding());
			System.out.println("defaultFormValueEncoding="+aRequest.defaultFormValueEncoding());
			System.out.println("isFormValueEncodingDetectionEnabled="+aRequest.isFormValueEncodingDetectionEnabled());
			System.out.println("------------ End Request Form Values ------------");
        }
    }//end method

	public static void logRequestContent(WORequest aRequest){
        if(aRequest!=null){
            NSData data=aRequest.content();
			System.out.println("------------ Begin Request Content ------------");
			System.out.println(new String(data.bytes(0,data.length())));
			System.out.println("------------ End Request Content ------------");
        }
    }//end method
    
	public static void logRequestProperties(WORequest aRequest){
        if(aRequest!=null){
			System.out.println("------------ Begin Request Properties ------------");
			System.out.println("httpVersion="+aRequest.httpVersion());
			System.out.println("uri="+aRequest.uri());
			System.out.println("method="+aRequest.method());
			System.out.println("sessionID="+aRequest.sessionID());
			System.out.println("adaptorPrefix="+aRequest.adaptorPrefix());
			System.out.println("applicationName="+aRequest.applicationName());
			System.out.println("applicationNumber="+aRequest.applicationNumber());
			System.out.println("browserLanguages="+aRequest. browserLanguages());
			System.out.println("requestHandlerKey="+aRequest. requestHandlerKey());
			System.out.println("requestHandlerPath="+aRequest.requestHandlerPath());
			System.out.println("isFromClientComponent="+aRequest.isFromClientComponent());
			System.out.println("userInfo="+aRequest.userInfo());
			System.out.println("------------ End Request Properties ------------");
        }
    }//end method

	public static void logRequestHeaders(WORequest aRequest){
       if(aRequest!=null){
			System.out.println("------------ Begin Request Headers ------------");
			Enumeration en=aRequest.headerKeys().objectEnumerator();
        	while(en.hasMoreElements()){
				String hdr=(String)en.nextElement();
				Enumeration en1=aRequest.headersForKey(hdr).objectEnumerator();
                while(en1.hasMoreElements()){
					System.out.println(hdr+":"+en1.nextElement());
                }
        	}
			System.out.println("------------ End Request Headers ------------");
        }
    }//end method


}//end class
