/* ResponseLogger.java created by Kelly Kazem on Wed 12-Jan-2000 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.webobjects.*;
import java.util.*;


public class ResponseLogger  {

	public static void logResponse(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logResponse for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			ResponseLogger.logResponse(aContext.response());
			System.out.println("**** Finished logResponse for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logResponseHeaders(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logResponseHeaders for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			ResponseLogger.logResponseHeaders(aContext.response());
			System.out.println("**** Finished logResponseHeaders for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logResponseContent(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logResponseContent for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			ResponseLogger.logResponseContent(aContext.response());
			System.out.println("**** Finished logResponseContent for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method


	public static void logResponseProperties(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logResponseProperties for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			ResponseLogger.logResponseProperties(aContext.response());
			System.out.println("**** Finished logResponseProperties for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logResponseCookies(WOContext aContext){
        if(aContext!=null){
			System.out.println("**** logResponseCookies for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
			ResponseLogger.logResponseCookies(aContext.response());
			System.out.println("**** Finished logResponseCookies for SessionID:"+aContext.session().sessionID()+" ContextID:"+aContext.contextID()+" ****");
        }
    }//end method

	public static void logResponse(WOResponse aResponse){
        if(aResponse!=null){
			System.out.println("******** Begin logResponse ********");
			ResponseLogger.logResponseProperties(aResponse);
			ResponseLogger.logResponseHeaders(aResponse);
			ResponseLogger.logResponseCookies(aResponse);
			ResponseLogger.logResponseContent(aResponse);
			System.out.println("******** End logResponse ********");
        }
    }//end method

	public static void logResponseCookies(WOResponse aResponse){
       if(aResponse!=null){
			System.out.println("------------ Begin Response Cookies ------------");
			Enumeration en=aResponse.cookies().objectEnumerator();
        	while(en.hasMoreElements()){
				System.out.println(en.nextElement());     
        	}
			System.out.println("------------ End Response Cookies ------------");
        }
    }//end method

	public static void logResponseContent(WOResponse aResponse){
        if(aResponse!=null){
            NSData data=aResponse.content();
			System.out.println("------------ Begin Response Content ------------");
			System.out.println(new String(data.bytes(0,data.length())));
			System.out.println("------------ End Response Content ------------");
        }
    }//end method


	public static void logResponseProperties(WOResponse aResponse){
        if(aResponse!=null){
			System.out.println("------------ Begin Response Properties ------------");
			System.out.println("httpVersion="+aResponse.httpVersion());
			System.out.println("http status="+aResponse.status());
			System.out.println("contentEncoding="+aResponse.contentEncoding());
			System.out.println("userInfo="+aResponse.userInfo());
			System.out.println("------------ End Response Properties ------------");
        }
    }//end method

	public static void logResponseHeaders(WOResponse aResponse){
       if(aResponse!=null){
			System.out.println("------------ Begin Response Headers ------------");
			Enumeration en=aResponse.headerKeys().objectEnumerator();
        	while(en.hasMoreElements()){
				String hdr=(String)en.nextElement();
				Enumeration en1=aResponse.headersForKey(hdr).objectEnumerator();
                while(en1.hasMoreElements()){
					System.out.println(hdr+":"+en1.nextElement());
                }
        	}
			System.out.println("------------ End Response Headers ------------");
        }
    }//end method


}//end class
